#ifndef TARTANALOOP_HH
#define TARTANALOOP_HH

class TArtEventStore;

class TArtAnaLoop
{
public:
  TArtAnaLoop(){;}
  virtual ~TArtAnaLoop(){;}

  virtual void AnaLoop(char* filename, int eventnumber = -1);

protected:
  virtual void Construct() = 0;
  virtual void Calculate() = 0;
  virtual void SuspendAction(){;}
  virtual void Destruct() = 0;

private:
  TArtEventStore *estore;

  static void *handle(void *ptr);
  enum EAnalysisState{WORKING, SUSPEND};
  static EAnalysisState kAnalysisState;
  int neve;
};

#endif
